package org.simantics.db.layer0.request;

import java.util.ArrayList;
import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.common.request.ObjectsWithType;
import org.simantics.db.common.request.ResourceRead;
import org.simantics.db.exception.DatabaseException;
import org.simantics.layer0.Layer0;
import org.simantics.simulation.ontology.SimulationResource;

/**
 * Returns a set of active models.
 * 
 * @author Tuukka Lehtonen
 */
public class ProjectModels extends ResourceRead<Collection<Resource>> {

    public ProjectModels(Resource project) {
        super(project);
    }

    @Override
    public Collection<Resource> perform(ReadGraph graph) throws DatabaseException {
        Layer0 L0 = Layer0.getInstance(graph);
        SimulationResource SIMU = SimulationResource.getInstance(graph);
        ArrayList<Resource> result = new ArrayList<Resource>();
        for (Resource model : graph.syncRequest(new ObjectsWithType(resource, L0.ConsistsOf, SIMU.Model))) {
            result.add(model);
        }
        return result;
    }

}
